"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchRequest,
    avro_parse,
    load_schema,
)


class SearchVariantsRequest(SearchRequest):
    """
    This request maps to the body of `POST /variants/search` as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "end",
        "referenceName",
        "start",
        "variantSetId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.SearchVariantsRequest": ga4gh_3_1_1.SearchVariantsRequest,
        }

    __slots__ = [
        "end",
        "referenceName",
        "start",
        "variantSetId",
        "callSetIds",
        "pageSize",
        "pageToken",
    ]

    def __init__(
        self,
        end,
        referenceName,
        start,
        variantSetId,
        callSetIds=None,
        pageSize=None,
        pageToken=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchVariantsRequest model.

        :param end:
            Required. The end of the window (0-based, exclusive) for which
            overlapping   variants should be returned.
        :type end: int
        :param referenceName:
            Required. Only return variants on this reference.
        :type referenceName: str
        :param start:
            Required. The beginning of the window (0-based, inclusive) for   which
            overlapping variants should be returned.   Genomic
            positions are non-negative integers less than reference
            length.   Requests spanning the join of circular genomes
            are represented as   two requests one on each side of the
            join (position 0).
        :type start: int
        :param variantSetId:
            The `VariantSet` to search.
        :type variantSetId: str
        :param callSetIds:
            Only return variant calls which belong to call sets with these IDs.
            If an empty array, returns variants without any call
            objects.   If null, returns all variant calls.
        :type callSetIds: None | list[str]
        :param pageSize:
            Specifies the maximum number of results to return in a single page.
            If unspecified, a system default will be used.
        :type pageSize: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets.   To get the next page of results, set this
            parameter to the value of   `nextPageToken` from the
            previous response.
        :type pageToken: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
